#include <stdio.h>
#include <stdlib.h>
#include <curses.h>
#include <term.h>
#include <panel.h>
#include <guile/gh.h>
#include <libguile.h>
#include <libguile/smob.h>

scm_bits_t SMOB_PANEL_ptr = (scm_bits_t)0;
scm_bits_t SMOB_SCREEN_ptr = (scm_bits_t)0;
scm_bits_t SMOB_TERMINAL_ptr = (scm_bits_t)0;
scm_bits_t SMOB_WINDOW_ptr = (scm_bits_t)0;
scm_bits_t SMOB_attr_t = (scm_bits_t)0;
scm_bits_t SMOB_chtype = (scm_bits_t)0;
scm_bits_t SMOB_chtype_ptr = (scm_bits_t)0;
scm_bits_t SMOB_mmask_t = (scm_bits_t)0;

SCM
scm_curses_get_stdscr()
{
	SCM SCM_ret;
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)stdscr);
	return SCM_ret;
}
SCM
scm_curses_string2chstr(SCM str)
{
	SCM SCM_ret;
	chtype *ch, *p;
	char *string;
	string = SCM_CHARS(str);
	ch = (chtype *)malloc(sizeof(chtype)*(strlen(string)+1));
	p=ch;
	while(*string)
	{
		*p = (chtype)(*string);
		p++;
		string++;
	}
	*p=0;
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_chtype_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)ch);
	return SCM_ret;
}
SCM
scm_curses_chstr2string(SCM chstr)
{
	SCM SCM_ret;
	char *str;
	chtype *ch;
	int len=0;
	ch = (chtype *)SCM_CDR(chstr);
	while(ch[len]!=0)
		++len;
	str = (char *)malloc(len+1);
	SCM_ret = scm_take0str(str);
	return SCM_ret;
}
SCM
scm_curses_chstr_ref(SCM chstr, SCM ind)
{
	return SCM_UNDEFINED;
}
SCM
scm_curses_chstr_set(SCM chstr, SCM ind, SCM obj)
{
	return SCM_UNDEFINED;
}
SCM
scm_curses_chstr_apply_bang(SCM attr, SCM chstr, SCM start, SCM end)
{
	chtype *ch;
	attr_t a = 0;
	ch = (chtype *)SCM_CDR(chstr);
		/* decide the attr type */
	if(SCM_CAR(attr)==SMOB_attr_t)
		a = (attr_t)SCM_CDR(attr);
	else if(SCM_CONSP(attr))
		while(SCM_CONSP(attr))
		{
			if(SCM_CAAR(attr)==SMOB_attr_t)
				a = a | (attr_t)SCM_CDAR(attr);
			attr = SCM_CDR(attr);
		}
		/* apply to the string, destructively */
	while(*ch)
	{
		*ch = *ch | a;
		ch++;	
	}
	return chstr;
}

SCM
scm_curses_new_panel(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_PANEL_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)new_panel(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_panel_above(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_PANEL_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)panel_above(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_panel_below(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_PANEL_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)panel_below(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_set_term(SCM _scm_new)
{
	SCM SCM_ret = (SCM)NULL;
	SCREEN* C__scm_new;
	C__scm_new = (SCREEN*)SCM_CDR(_scm_new);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_SCREEN_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)set_term(C__scm_new));
	return SCM_ret;
}

SCM
scm_curses_set_curterm(SCM _scm_nterm)
{
	SCM SCM_ret = (SCM)NULL;
	TERMINAL* C__scm_nterm;
	C__scm_nterm = (TERMINAL*)SCM_CDR(_scm_nterm);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_TERMINAL_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)set_curterm(C__scm_nterm));
	return SCM_ret;
}

SCM
scm_curses_derwin(SCM _scm_orig, SCM _scm_nlines, SCM _scm_ncols, SCM _scm_begin_y, SCM _scm_begin_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_orig;
	int C__scm_nlines;
	int C__scm_ncols;
	int C__scm_begin_y;
	int C__scm_begin_x;
	C__scm_orig = (WINDOW*)SCM_CDR(_scm_orig);
	C__scm_nlines = SCM_INUM(_scm_nlines);
	C__scm_ncols = SCM_INUM(_scm_ncols);
	C__scm_begin_y = SCM_INUM(_scm_begin_y);
	C__scm_begin_x = SCM_INUM(_scm_begin_x);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)derwin(C__scm_orig, C__scm_nlines, C__scm_ncols, C__scm_begin_y, C__scm_begin_x));
	return SCM_ret;
}

SCM
scm_curses_dupwin(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)dupwin(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_initscr()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)initscr());
	return SCM_ret;
}

SCM
scm_curses_newpad(SCM _scm_nlines, SCM _scm_ncols)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_nlines;
	int C__scm_ncols;
	C__scm_nlines = SCM_INUM(_scm_nlines);
	C__scm_ncols = SCM_INUM(_scm_ncols);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)newpad(C__scm_nlines, C__scm_ncols));
	return SCM_ret;
}

SCM
scm_curses_newwin(SCM _scm_nlines, SCM _scm_ncols, SCM _scm_begin_y, SCM _scm_begin_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_nlines;
	int C__scm_ncols;
	int C__scm_begin_y;
	int C__scm_begin_x;
	C__scm_nlines = SCM_INUM(_scm_nlines);
	C__scm_ncols = SCM_INUM(_scm_ncols);
	C__scm_begin_y = SCM_INUM(_scm_begin_y);
	C__scm_begin_x = SCM_INUM(_scm_begin_x);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)newwin(C__scm_nlines, C__scm_ncols, C__scm_begin_y, C__scm_begin_x));
	return SCM_ret;
}

SCM
scm_curses_panel_window(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)panel_window(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_subpad(SCM _scm_orig, SCM _scm_nlines, SCM _scm_ncols, SCM _scm_begin_y, SCM _scm_begin_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_orig;
	int C__scm_nlines;
	int C__scm_ncols;
	int C__scm_begin_y;
	int C__scm_begin_x;
	C__scm_orig = (WINDOW*)SCM_CDR(_scm_orig);
	C__scm_nlines = SCM_INUM(_scm_nlines);
	C__scm_ncols = SCM_INUM(_scm_ncols);
	C__scm_begin_y = SCM_INUM(_scm_begin_y);
	C__scm_begin_x = SCM_INUM(_scm_begin_x);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)subpad(C__scm_orig, C__scm_nlines, C__scm_ncols, C__scm_begin_y, C__scm_begin_x));
	return SCM_ret;
}

SCM
scm_curses_subwin(SCM _scm_orig, SCM _scm_nlines, SCM _scm_ncols, SCM _scm_begin_y, SCM _scm_begin_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_orig;
	int C__scm_nlines;
	int C__scm_ncols;
	int C__scm_begin_y;
	int C__scm_begin_x;
	C__scm_orig = (WINDOW*)SCM_CDR(_scm_orig);
	C__scm_nlines = SCM_INUM(_scm_nlines);
	C__scm_ncols = SCM_INUM(_scm_ncols);
	C__scm_begin_y = SCM_INUM(_scm_begin_y);
	C__scm_begin_x = SCM_INUM(_scm_begin_x);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_WINDOW_ptr);
	SCM_SETCDR(SCM_ret, (unsigned int)subwin(C__scm_orig, C__scm_nlines, C__scm_ncols, C__scm_begin_y, C__scm_begin_x));
	return SCM_ret;
}

SCM
scm_curses_slk_attr()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_attr_t);
	SCM_SETCDR(SCM_ret, (unsigned int)slk_attr());
	return SCM_ret;
}

SCM
scm_curses_termattrs()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_attr_t);
	SCM_SETCDR(SCM_ret, (unsigned int)termattrs());
	return SCM_ret;
}

SCM
scm_curses_can_change_color()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = (can_change_color())==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_has_colors()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = (has_colors())==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_has_ic()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = (has_ic())==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_has_il()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = (has_il())==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_is_linetouched(SCM _scm_win, SCM _scm_line)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_line;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_line = SCM_INUM(_scm_line);
	SCM_ret = (is_linetouched(C__scm_win, C__scm_line))==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_is_wintouched(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = (is_wintouched(C__scm_win))==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_isendwin()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = (isendwin())==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_wenclose(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = (wenclose(C__scm_win, C__scm_y, C__scm_x))==TRUE?SCM_BOOL_T:SCM_BOOL_F;
	return SCM_ret;
}

SCM
scm_curses_keyname(SCM _scm_c)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_c;
	C__scm_c = SCM_INUM(_scm_c);
	SCM_ret = scm_take0str(keyname(C__scm_c));
	return SCM_ret;
}

SCM
scm_curses_longname()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = scm_take0str(longname());
	return SCM_ret;
}

SCM
scm_curses_slk_label(SCM _scm_labnum)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_labnum;
	C__scm_labnum = SCM_INUM(_scm_labnum);
	SCM_ret = scm_take0str(slk_label(C__scm_labnum));
	return SCM_ret;
}

SCM
scm_curses_termname()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = scm_take0str(termname());
	return SCM_ret;
}

SCM
scm_curses_tgoto(SCM _scm_cap, SCM _scm_col, SCM _scm_row)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_cap;
	int C__scm_col;
	int C__scm_row;
	C__scm_cap = SCM_CHARS(_scm_cap);
	C__scm_col = SCM_INUM(_scm_col);
	C__scm_row = SCM_INUM(_scm_row);
	SCM_ret = scm_take0str(tgoto(C__scm_cap, C__scm_col, C__scm_row));
	return SCM_ret;
}

SCM
scm_curses_tigetstr(SCM _scm_capname)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_capname;
	C__scm_capname = SCM_CHARS(_scm_capname);
	SCM_ret = scm_take0str(tigetstr(C__scm_capname));
	return SCM_ret;
}

SCM
scm_curses_unctrl(SCM _scm_c)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_c;
	C__scm_c = (chtype)SCM_CDR(_scm_c);
	SCM_ret = scm_take0str(unctrl(C__scm_c));
	return SCM_ret;
}

SCM
scm_curses_erasechar()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = gh_char2scm(erasechar());
	return SCM_ret;
}

SCM
scm_curses_killchar()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = gh_char2scm(killchar());
	return SCM_ret;
}

SCM
scm_curses_getbkgd(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_chtype);
	SCM_SETCDR(SCM_ret, (unsigned int)getbkgd(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_inch()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_chtype);
	SCM_SETCDR(SCM_ret, (unsigned int)inch());
	return SCM_ret;
}

SCM
scm_curses_mvinch(SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_chtype);
	SCM_SETCDR(SCM_ret, (unsigned int)mvinch(C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_mvwinch(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_chtype);
	SCM_SETCDR(SCM_ret, (unsigned int)mvwinch(C__scm_win, C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_winch(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_chtype);
	SCM_SETCDR(SCM_ret, (unsigned int)winch(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_panel_userptr(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = PTR2SCM(panel_userptr(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_addch(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(addch(C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_addchnstr(SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(addchnstr(C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_addchstr(SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	chtype* C__scm_chstr;
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(addchstr(C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_addnstr(SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	int C__scm_n;
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(addnstr(C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_addstr(SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(addstr(C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_attr_off(SCM _scm_attrs, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	attr_t C__scm_attrs;
	void* C__scm_opts;
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(attr_off(C__scm_attrs, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_attr_on(SCM _scm_attrs, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	attr_t C__scm_attrs;
	void* C__scm_opts;
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(attr_on(C__scm_attrs, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_attr_set(SCM _scm_attrs, SCM _scm_pair, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	attr_t C__scm_attrs;
	short C__scm_pair;
	void* C__scm_opts;
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_pair = (short)SCM_INUM(_scm_pair);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(attr_set(C__scm_attrs, C__scm_pair, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_attroff(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_attrs;
	C__scm_attrs = SCM_INUM(_scm_attrs);
	SCM_ret = SCM_MAKINUM(attroff(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_attron(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_attrs;
	C__scm_attrs = SCM_INUM(_scm_attrs);
	SCM_ret = SCM_MAKINUM(attron(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_attrset(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_attrs;
	C__scm_attrs = SCM_INUM(_scm_attrs);
	SCM_ret = SCM_MAKINUM(attrset(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_baudrate()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(baudrate());
	return SCM_ret;
}

SCM
scm_curses_beep()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(beep());
	return SCM_ret;
}

SCM
scm_curses_bkgd(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(bkgd(C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_border(SCM _scm_ls, SCM _scm_rs, SCM _scm_ts, SCM _scm_bs, SCM _scm_tl, SCM _scm_tr, SCM _scm_bl, SCM _scm_br)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ls;
	chtype C__scm_rs;
	chtype C__scm_ts;
	chtype C__scm_bs;
	chtype C__scm_tl;
	chtype C__scm_tr;
	chtype C__scm_bl;
	chtype C__scm_br;
	C__scm_ls = (chtype)SCM_CDR(_scm_ls);
	C__scm_rs = (chtype)SCM_CDR(_scm_rs);
	C__scm_ts = (chtype)SCM_CDR(_scm_ts);
	C__scm_bs = (chtype)SCM_CDR(_scm_bs);
	C__scm_tl = (chtype)SCM_CDR(_scm_tl);
	C__scm_tr = (chtype)SCM_CDR(_scm_tr);
	C__scm_bl = (chtype)SCM_CDR(_scm_bl);
	C__scm_br = (chtype)SCM_CDR(_scm_br);
	SCM_ret = SCM_MAKINUM(border(C__scm_ls, C__scm_rs, C__scm_ts, C__scm_bs, C__scm_tl, C__scm_tr, C__scm_bl, C__scm_br));
	return SCM_ret;
}

SCM
scm_curses_bottom_panel(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = SCM_MAKINUM(bottom_panel(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_box(SCM _scm_win, SCM _scm_verch, SCM _scm_horch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_verch;
	chtype C__scm_horch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_verch = (chtype)SCM_CDR(_scm_verch);
	C__scm_horch = (chtype)SCM_CDR(_scm_horch);
	SCM_ret = SCM_MAKINUM(box(C__scm_win, C__scm_verch, C__scm_horch));
	return SCM_ret;
}

SCM
scm_curses_cbreak()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(cbreak());
	return SCM_ret;
}

SCM
scm_curses_chgat(SCM _scm_n, SCM _scm_attr, SCM _scm_color, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_n;
	attr_t C__scm_attr;
	short C__scm_color;
	void* C__scm_opts;
	C__scm_n = SCM_INUM(_scm_n);
	C__scm_attr = (attr_t)SCM_CDR(_scm_attr);
	C__scm_color = (short)SCM_INUM(_scm_color);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(chgat(C__scm_n, C__scm_attr, C__scm_color, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_clear()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(clear());
	return SCM_ret;
}

SCM
scm_curses_clearok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(clearok(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_clrtobot()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(clrtobot());
	return SCM_ret;
}

SCM
scm_curses_clrtoeol()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(clrtoeol());
	return SCM_ret;
}

SCM
scm_curses_color_set(SCM _scm_color_pair_number, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	short C__scm_color_pair_number;
	void* C__scm_opts;
	C__scm_color_pair_number = (short)SCM_INUM(_scm_color_pair_number);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(color_set(C__scm_color_pair_number, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_copywin(SCM _scm_srcwin, SCM _scm_dstwin, SCM _scm_sminrow, SCM _scm_smincol, SCM _scm_dminrow, SCM _scm_dmincol, SCM _scm_dmaxrow, SCM _scm_dmaxcol, SCM _scm_overlay)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_srcwin;
	WINDOW* C__scm_dstwin;
	int C__scm_sminrow;
	int C__scm_smincol;
	int C__scm_dminrow;
	int C__scm_dmincol;
	int C__scm_dmaxrow;
	int C__scm_dmaxcol;
	int C__scm_overlay;
	C__scm_srcwin = (WINDOW*)SCM_CDR(_scm_srcwin);
	C__scm_dstwin = (WINDOW*)SCM_CDR(_scm_dstwin);
	C__scm_sminrow = SCM_INUM(_scm_sminrow);
	C__scm_smincol = SCM_INUM(_scm_smincol);
	C__scm_dminrow = SCM_INUM(_scm_dminrow);
	C__scm_dmincol = SCM_INUM(_scm_dmincol);
	C__scm_dmaxrow = SCM_INUM(_scm_dmaxrow);
	C__scm_dmaxcol = SCM_INUM(_scm_dmaxcol);
	C__scm_overlay = SCM_INUM(_scm_overlay);
	SCM_ret = SCM_MAKINUM(copywin(C__scm_srcwin, C__scm_dstwin, C__scm_sminrow, C__scm_smincol, C__scm_dminrow, C__scm_dmincol, C__scm_dmaxrow, C__scm_dmaxcol, C__scm_overlay));
	return SCM_ret;
}

SCM
scm_curses_curs_set(SCM _scm_visibility)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_visibility;
	C__scm_visibility = SCM_INUM(_scm_visibility);
	SCM_ret = SCM_MAKINUM(curs_set(C__scm_visibility));
	return SCM_ret;
}

SCM
scm_curses_def_prog_mode()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(def_prog_mode());
	return SCM_ret;
}

SCM
scm_curses_def_shell_mode()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(def_shell_mode());
	return SCM_ret;
}

SCM
scm_curses_del_curterm(SCM _scm_oterm)
{
	SCM SCM_ret = (SCM)NULL;
	TERMINAL* C__scm_oterm;
	C__scm_oterm = (TERMINAL*)SCM_CDR(_scm_oterm);
	SCM_ret = SCM_MAKINUM(del_curterm(C__scm_oterm));
	return SCM_ret;
}

SCM
scm_curses_del_panel(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = SCM_MAKINUM(del_panel(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_delay_output(SCM _scm_ms)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_ms;
	C__scm_ms = SCM_INUM(_scm_ms);
	SCM_ret = SCM_MAKINUM(delay_output(C__scm_ms));
	return SCM_ret;
}

SCM
scm_curses_delch()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(delch());
	return SCM_ret;
}

SCM
scm_curses_deleteln()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(deleteln());
	return SCM_ret;
}

SCM
scm_curses_delwin(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(delwin(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_doupdate()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(doupdate());
	return SCM_ret;
}

SCM
scm_curses_echo()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(echo());
	return SCM_ret;
}

SCM
scm_curses_echochar(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(echochar(C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_endwin()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(endwin());
	return SCM_ret;
}

SCM
scm_curses_erase()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(erase());
	return SCM_ret;
}

SCM
scm_curses_flash()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(flash());
	return SCM_ret;
}

SCM
scm_curses_flushinp()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(flushinp());
	return SCM_ret;
}

SCM
scm_curses_getch()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(getch());
	return SCM_ret;
}

SCM
scm_curses_getnstr(SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	int C__scm_n;
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(getnstr(C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_getstr(SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(getstr(C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_halfdelay(SCM _scm_tenths)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_tenths;
	C__scm_tenths = SCM_INUM(_scm_tenths);
	SCM_ret = SCM_MAKINUM(halfdelay(C__scm_tenths));
	return SCM_ret;
}

SCM
scm_curses_has_key(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_ch;
	C__scm_ch = SCM_INUM(_scm_ch);
	SCM_ret = SCM_MAKINUM(has_key(C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_hide_panel(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = SCM_MAKINUM(hide_panel(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_hline(SCM _scm_ch, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	int C__scm_n;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(hline(C__scm_ch, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_idlok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(idlok(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_inchnstr(SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(inchnstr(C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_inchstr(SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	chtype* C__scm_chstr;
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(inchstr(C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_init_color(SCM _scm_color, SCM _scm_r, SCM _scm_g, SCM _scm_b)
{
	SCM SCM_ret = (SCM)NULL;
	short C__scm_color;
	short C__scm_r;
	short C__scm_g;
	short C__scm_b;
	C__scm_color = (short)SCM_INUM(_scm_color);
	C__scm_r = (short)SCM_INUM(_scm_r);
	C__scm_g = (short)SCM_INUM(_scm_g);
	C__scm_b = (short)SCM_INUM(_scm_b);
	SCM_ret = SCM_MAKINUM(init_color(C__scm_color, C__scm_r, C__scm_g, C__scm_b));
	return SCM_ret;
}

SCM
scm_curses_COLOR_PAIR(SCM _scm_c)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_c;
	C__scm_c = SCM_INUM(_scm_c);
	SCM_NEWCELL(SCM_ret);
	SCM_SETCAR(SCM_ret, SMOB_attr_t);
	SCM_SETCDR(SCM_ret, (unsigned int)COLOR_PAIR(C__scm_c));
	return SCM_ret;
}

SCM
scm_curses_init_pair(SCM _scm_pair, SCM _scm_f, SCM _scm_b)
{
	SCM SCM_ret = (SCM)NULL;
	short C__scm_pair;
	short C__scm_f;
	short C__scm_b;
	C__scm_pair = (short)SCM_INUM(_scm_pair);
	C__scm_f = (short)SCM_INUM(_scm_f);
	C__scm_b = (short)SCM_INUM(_scm_b);
	SCM_ret = SCM_MAKINUM(init_pair(C__scm_pair, C__scm_f, C__scm_b));
	return SCM_ret;
}

SCM
scm_curses_innstr(SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	int C__scm_n;
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(innstr(C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_insch(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(insch(C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_insdelln(SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_n;
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(insdelln(C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_insertln()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(insertln());
	return SCM_ret;
}

SCM
scm_curses_insnstr(SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	int C__scm_n;
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(insnstr(C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_insstr(SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(insstr(C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_instr(SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(instr(C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_intrflush(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(intrflush(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_keypad(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(keypad(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_leaveok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(leaveok(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_mcprint(SCM _scm_data, SCM _scm_len)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_data;
	int C__scm_len;
	C__scm_data = SCM_CHARS(_scm_data);
	C__scm_len = SCM_INUM(_scm_len);
	SCM_ret = SCM_MAKINUM(mcprint(C__scm_data, C__scm_len));
	return SCM_ret;
}

SCM
scm_curses_meta(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(meta(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_mouseinterval(SCM _scm_erval)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_erval;
	C__scm_erval = SCM_INUM(_scm_erval);
	SCM_ret = SCM_MAKINUM(mouseinterval(C__scm_erval));
	return SCM_ret;
}

SCM
scm_curses_move(SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(move(C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_move_panel(SCM _scm_pan, SCM _scm_starty, SCM _scm_startx)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	int C__scm_starty;
	int C__scm_startx;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	C__scm_starty = SCM_INUM(_scm_starty);
	C__scm_startx = SCM_INUM(_scm_startx);
	SCM_ret = SCM_MAKINUM(move_panel(C__scm_pan, C__scm_starty, C__scm_startx));
	return SCM_ret;
}

SCM
scm_curses_mvaddch(SCM _scm_y, SCM _scm_x, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype C__scm_ch;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(mvaddch(C__scm_y, C__scm_x, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_mvaddchnstr(SCM _scm_y, SCM _scm_x, SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvaddchnstr(C__scm_y, C__scm_x, C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvaddchstr(SCM _scm_y, SCM _scm_x, SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(mvaddchstr(C__scm_y, C__scm_x, C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_mvaddnstr(SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvaddnstr(C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvaddstr(SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvaddstr(C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvchgat(SCM _scm_y, SCM _scm_x, SCM _scm_n, SCM _scm_attr, SCM _scm_color, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	int C__scm_n;
	attr_t C__scm_attr;
	short C__scm_color;
	void* C__scm_opts;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_n = SCM_INUM(_scm_n);
	C__scm_attr = (attr_t)SCM_CDR(_scm_attr);
	C__scm_color = (short)SCM_INUM(_scm_color);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(mvchgat(C__scm_y, C__scm_x, C__scm_n, C__scm_attr, C__scm_color, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_mvcur(SCM _scm_oldrow, SCM _scm_oldcol, SCM _scm_newrow, SCM _scm_newcol)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_oldrow;
	int C__scm_oldcol;
	int C__scm_newrow;
	int C__scm_newcol;
	C__scm_oldrow = SCM_INUM(_scm_oldrow);
	C__scm_oldcol = SCM_INUM(_scm_oldcol);
	C__scm_newrow = SCM_INUM(_scm_newrow);
	C__scm_newcol = SCM_INUM(_scm_newcol);
	SCM_ret = SCM_MAKINUM(mvcur(C__scm_oldrow, C__scm_oldcol, C__scm_newrow, C__scm_newcol));
	return SCM_ret;
}

SCM
scm_curses_mvdelch(SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(mvdelch(C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_mvderwin(SCM _scm_win, SCM _scm_par_y, SCM _scm_par_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_par_y;
	int C__scm_par_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_par_y = SCM_INUM(_scm_par_y);
	C__scm_par_x = SCM_INUM(_scm_par_x);
	SCM_ret = SCM_MAKINUM(mvderwin(C__scm_win, C__scm_par_y, C__scm_par_x));
	return SCM_ret;
}

SCM
scm_curses_mvgetch(SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(mvgetch(C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_mvgetnstr(SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvgetnstr(C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvgetstr(SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvgetstr(C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvinchnstr(SCM _scm_y, SCM _scm_x, SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvinchnstr(C__scm_y, C__scm_x, C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvinchstr(SCM _scm_y, SCM _scm_x, SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(mvinchstr(C__scm_y, C__scm_x, C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_mvinnstr(SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvinnstr(C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvinsch(SCM _scm_y, SCM _scm_x, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype C__scm_ch;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(mvinsch(C__scm_y, C__scm_x, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_mvinsnstr(SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvinsnstr(C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvinsstr(SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvinsstr(C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvinstr(SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvinstr(C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvvline(SCM _scm_y, SCM _scm_x, SCM _scm_ch, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	chtype C__scm_ch;
	int C__scm_n;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvvline(C__scm_y, C__scm_x, C__scm_ch, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwaddch(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(mvwaddch(C__scm_win, C__scm_y, C__scm_x, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_mvwaddchnstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwaddchnstr(C__scm_win, C__scm_y, C__scm_x, C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwaddchstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(mvwaddchstr(C__scm_win, C__scm_y, C__scm_x, C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_mvwaddnstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwaddnstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwaddstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvwaddstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvwchgat(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_n, SCM _scm_attr, SCM _scm_color, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	int C__scm_n;
	attr_t C__scm_attr;
	short C__scm_color;
	void* C__scm_opts;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_n = SCM_INUM(_scm_n);
	C__scm_attr = (attr_t)SCM_CDR(_scm_attr);
	C__scm_color = (short)SCM_INUM(_scm_color);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(mvwchgat(C__scm_win, C__scm_y, C__scm_x, C__scm_n, C__scm_attr, C__scm_color, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_mvwdelch(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(mvwdelch(C__scm_win, C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_mvwgetch(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(mvwgetch(C__scm_win, C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_mvwgetnstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwgetnstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwgetstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvwgetstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvwin(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(mvwin(C__scm_win, C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_mvwinchnstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwinchnstr(C__scm_win, C__scm_y, C__scm_x, C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwinchstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype* C__scm_chstr;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(mvwinchstr(C__scm_win, C__scm_y, C__scm_x, C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_mvwinnstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwinnstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwinsch(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(mvwinsch(C__scm_win, C__scm_y, C__scm_x, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_mvwinsnstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwinsnstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_mvwinsstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvwinsstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvwinstr(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(mvwinstr(C__scm_win, C__scm_y, C__scm_x, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_mvwvline(SCM _scm_win, SCM _scm_y, SCM _scm_x, SCM _scm_ch, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	chtype C__scm_ch;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(mvwvline(C__scm_win, C__scm_y, C__scm_x, C__scm_ch, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_napms(SCM _scm_ms)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_ms;
	C__scm_ms = SCM_INUM(_scm_ms);
	SCM_ret = SCM_MAKINUM(napms(C__scm_ms));
	return SCM_ret;
}

SCM
scm_curses_nl()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(nl());
	return SCM_ret;
}

SCM
scm_curses_nocbreak()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(nocbreak());
	return SCM_ret;
}

SCM
scm_curses_nodelay(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(nodelay(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_noecho()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(noecho());
	return SCM_ret;
}

SCM
scm_curses_nonl()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(nonl());
	return SCM_ret;
}

SCM
scm_curses_noraw()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(noraw());
	return SCM_ret;
}

SCM
scm_curses_notimeout(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(notimeout(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_overlay(SCM _scm_srcwin, SCM _scm_dstwin)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_srcwin;
	WINDOW* C__scm_dstwin;
	C__scm_srcwin = (WINDOW*)SCM_CDR(_scm_srcwin);
	C__scm_dstwin = (WINDOW*)SCM_CDR(_scm_dstwin);
	SCM_ret = SCM_MAKINUM(overlay(C__scm_srcwin, C__scm_dstwin));
	return SCM_ret;
}

SCM
scm_curses_overwrite(SCM _scm_srcwin, SCM _scm_dstwin)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_srcwin;
	WINDOW* C__scm_dstwin;
	C__scm_srcwin = (WINDOW*)SCM_CDR(_scm_srcwin);
	C__scm_dstwin = (WINDOW*)SCM_CDR(_scm_dstwin);
	SCM_ret = SCM_MAKINUM(overwrite(C__scm_srcwin, C__scm_dstwin));
	return SCM_ret;
}

SCM
scm_curses_panel_hidden(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = SCM_MAKINUM(panel_hidden(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_pechochar(SCM _scm_pad, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_pad;
	chtype C__scm_ch;
	C__scm_pad = (WINDOW*)SCM_CDR(_scm_pad);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(pechochar(C__scm_pad, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_pnoutrefresh(SCM _scm_pad, SCM _scm_pminrow, SCM _scm_pmincol, SCM _scm_sminrow, SCM _scm_smincol, SCM _scm_smaxrow, SCM _scm_smaxcol)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_pad;
	int C__scm_pminrow;
	int C__scm_pmincol;
	int C__scm_sminrow;
	int C__scm_smincol;
	int C__scm_smaxrow;
	int C__scm_smaxcol;
	C__scm_pad = (WINDOW*)SCM_CDR(_scm_pad);
	C__scm_pminrow = SCM_INUM(_scm_pminrow);
	C__scm_pmincol = SCM_INUM(_scm_pmincol);
	C__scm_sminrow = SCM_INUM(_scm_sminrow);
	C__scm_smincol = SCM_INUM(_scm_smincol);
	C__scm_smaxrow = SCM_INUM(_scm_smaxrow);
	C__scm_smaxcol = SCM_INUM(_scm_smaxcol);
	SCM_ret = SCM_MAKINUM(pnoutrefresh(C__scm_pad, C__scm_pminrow, C__scm_pmincol, C__scm_sminrow, C__scm_smincol, C__scm_smaxrow, C__scm_smaxcol));
	return SCM_ret;
}

SCM
scm_curses_prefresh(SCM _scm_pad, SCM _scm_pminrow, SCM _scm_pmincol, SCM _scm_sminrow, SCM _scm_smincol, SCM _scm_smaxrow, SCM _scm_smaxcol)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_pad;
	int C__scm_pminrow;
	int C__scm_pmincol;
	int C__scm_sminrow;
	int C__scm_smincol;
	int C__scm_smaxrow;
	int C__scm_smaxcol;
	C__scm_pad = (WINDOW*)SCM_CDR(_scm_pad);
	C__scm_pminrow = SCM_INUM(_scm_pminrow);
	C__scm_pmincol = SCM_INUM(_scm_pmincol);
	C__scm_sminrow = SCM_INUM(_scm_sminrow);
	C__scm_smincol = SCM_INUM(_scm_smincol);
	C__scm_smaxrow = SCM_INUM(_scm_smaxrow);
	C__scm_smaxcol = SCM_INUM(_scm_smaxcol);
	SCM_ret = SCM_MAKINUM(prefresh(C__scm_pad, C__scm_pminrow, C__scm_pmincol, C__scm_sminrow, C__scm_smincol, C__scm_smaxrow, C__scm_smaxcol));
	return SCM_ret;
}

SCM
scm_curses_putp(SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_str;
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(putp(C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_raw()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(raw());
	return SCM_ret;
}

SCM
scm_curses_redrawwin(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(redrawwin(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_refresh()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(refresh());
	return SCM_ret;
}

SCM
scm_curses_replace_panel(SCM _scm_pan, SCM _scm_window)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	WINDOW* C__scm_window;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	C__scm_window = (WINDOW*)SCM_CDR(_scm_window);
	SCM_ret = SCM_MAKINUM(replace_panel(C__scm_pan, C__scm_window));
	return SCM_ret;
}

SCM
scm_curses_reset_prog_mode()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(reset_prog_mode());
	return SCM_ret;
}

SCM
scm_curses_reset_shell_mode()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(reset_shell_mode());
	return SCM_ret;
}

SCM
scm_curses_resetty()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(resetty());
	return SCM_ret;
}

SCM
scm_curses_resizeterm(SCM _scm_lines, SCM _scm_columns)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_lines;
	int C__scm_columns;
	C__scm_lines = SCM_INUM(_scm_lines);
	C__scm_columns = SCM_INUM(_scm_columns);
	SCM_ret = SCM_MAKINUM(resizeterm(C__scm_lines, C__scm_columns));
	return SCM_ret;
}

SCM
scm_curses_savetty()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(savetty());
	return SCM_ret;
}

SCM
scm_curses_scr_dump(SCM _scm_filename)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_filename;
	C__scm_filename = SCM_CHARS(_scm_filename);
	SCM_ret = SCM_MAKINUM(scr_dump(C__scm_filename));
	return SCM_ret;
}

SCM
scm_curses_scr_init(SCM _scm_filename)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_filename;
	C__scm_filename = SCM_CHARS(_scm_filename);
	SCM_ret = SCM_MAKINUM(scr_init(C__scm_filename));
	return SCM_ret;
}

SCM
scm_curses_scr_restore(SCM _scm_filename)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_filename;
	C__scm_filename = SCM_CHARS(_scm_filename);
	SCM_ret = SCM_MAKINUM(scr_restore(C__scm_filename));
	return SCM_ret;
}

SCM
scm_curses_scr_set(SCM _scm_filename)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_filename;
	C__scm_filename = SCM_CHARS(_scm_filename);
	SCM_ret = SCM_MAKINUM(scr_set(C__scm_filename));
	return SCM_ret;
}

SCM
scm_curses_scrl(SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_n;
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(scrl(C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_scroll(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(scroll(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_scrollok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(scrollok(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_set_panel_userptr(SCM _scm_pan, SCM _scm_ptr)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	void* C__scm_ptr;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	C__scm_ptr = SCM2PTR(_scm_ptr);
	SCM_ret = SCM_MAKINUM(set_panel_userptr(C__scm_pan, C__scm_ptr));
	return SCM_ret;
}

SCM
scm_curses_setscrreg(SCM _scm_top, SCM _scm_bot)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_top;
	int C__scm_bot;
	C__scm_top = SCM_INUM(_scm_top);
	C__scm_bot = SCM_INUM(_scm_bot);
	SCM_ret = SCM_MAKINUM(setscrreg(C__scm_top, C__scm_bot));
	return SCM_ret;
}

SCM
scm_curses_setterm(SCM _scm_term)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_term;
	C__scm_term = SCM_CHARS(_scm_term);
	SCM_ret = SCM_MAKINUM(setterm(C__scm_term));
	return SCM_ret;
}

SCM
scm_curses_show_panel(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = SCM_MAKINUM(show_panel(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_slk_attr_off(SCM _scm_attrs, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	attr_t C__scm_attrs;
	void* C__scm_opts;
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(slk_attr_off(C__scm_attrs, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_slk_attr_on(SCM _scm_attrs, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	attr_t C__scm_attrs;
	void* C__scm_opts;
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(slk_attr_on(C__scm_attrs, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_slk_attr_set(SCM _scm_attrs, SCM _scm_color_pair_number, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	attr_t C__scm_attrs;
	short C__scm_color_pair_number;
	void* C__scm_opts;
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_color_pair_number = (short)SCM_INUM(_scm_color_pair_number);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(slk_attr_set(C__scm_attrs, C__scm_color_pair_number, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_slk_attroff(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_attrs;
	C__scm_attrs = (chtype)SCM_CDR(_scm_attrs);
	SCM_ret = SCM_MAKINUM(slk_attroff(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_slk_attron(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_attrs;
	C__scm_attrs = (chtype)SCM_CDR(_scm_attrs);
	SCM_ret = SCM_MAKINUM(slk_attron(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_slk_attrset(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_attrs;
	C__scm_attrs = (chtype)SCM_CDR(_scm_attrs);
	SCM_ret = SCM_MAKINUM(slk_attrset(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_slk_clear()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(slk_clear());
	return SCM_ret;
}

SCM
scm_curses_slk_color(SCM _scm_color_pair_number)
{
	SCM SCM_ret = (SCM)NULL;
	short C__scm_color_pair_number;
	C__scm_color_pair_number = (short)SCM_INUM(_scm_color_pair_number);
	SCM_ret = SCM_MAKINUM(slk_color(C__scm_color_pair_number));
	return SCM_ret;
}

SCM
scm_curses_slk_init(SCM _scm_fmt)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_fmt;
	C__scm_fmt = SCM_INUM(_scm_fmt);
	SCM_ret = SCM_MAKINUM(slk_init(C__scm_fmt));
	return SCM_ret;
}

SCM
scm_curses_slk_noutrefresh()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(slk_noutrefresh());
	return SCM_ret;
}

SCM
scm_curses_slk_refresh()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(slk_refresh());
	return SCM_ret;
}

SCM
scm_curses_slk_restore()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(slk_restore());
	return SCM_ret;
}

SCM
scm_curses_slk_set(SCM _scm_labnum, SCM _scm_label, SCM _scm_fmt)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_labnum;
	char* C__scm_label;
	int C__scm_fmt;
	C__scm_labnum = SCM_INUM(_scm_labnum);
	C__scm_label = SCM_CHARS(_scm_label);
	C__scm_fmt = SCM_INUM(_scm_fmt);
	SCM_ret = SCM_MAKINUM(slk_set(C__scm_labnum, C__scm_label, C__scm_fmt));
	return SCM_ret;
}

SCM
scm_curses_slk_touch()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(slk_touch());
	return SCM_ret;
}

SCM
scm_curses_standend()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(standend());
	return SCM_ret;
}

SCM
scm_curses_standout()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(standout());
	return SCM_ret;
}

SCM
scm_curses_start_color()
{
	SCM SCM_ret = (SCM)NULL;
	SCM_ret = SCM_MAKINUM(start_color());
	return SCM_ret;
}

SCM
scm_curses_syncok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	SCM_ret = SCM_MAKINUM(syncok(C__scm_win, C__scm_bf));
	return SCM_ret;
}

SCM
scm_curses_tgetent(SCM _scm_bp, SCM _scm_name)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_bp;
	char* C__scm_name;
	C__scm_bp = SCM_CHARS(_scm_bp);
	C__scm_name = SCM_CHARS(_scm_name);
	SCM_ret = SCM_MAKINUM(tgetent(C__scm_bp, C__scm_name));
	return SCM_ret;
}

SCM
scm_curses_tgetflag(SCM _scm_id)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_id;
	C__scm_id = SCM_CHARS(_scm_id);
	SCM_ret = SCM_MAKINUM(tgetflag(C__scm_id));
	return SCM_ret;
}

SCM
scm_curses_tgetnum(SCM _scm_id)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_id;
	C__scm_id = SCM_CHARS(_scm_id);
	SCM_ret = SCM_MAKINUM(tgetnum(C__scm_id));
	return SCM_ret;
}

SCM
scm_curses_tigetflag(SCM _scm_capname)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_capname;
	C__scm_capname = SCM_CHARS(_scm_capname);
	SCM_ret = SCM_MAKINUM(tigetflag(C__scm_capname));
	return SCM_ret;
}

SCM
scm_curses_tigetnum(SCM _scm_capname)
{
	SCM SCM_ret = (SCM)NULL;
	char* C__scm_capname;
	C__scm_capname = SCM_CHARS(_scm_capname);
	SCM_ret = SCM_MAKINUM(tigetnum(C__scm_capname));
	return SCM_ret;
}

SCM
scm_curses_top_panel(SCM _scm_pan)
{
	SCM SCM_ret = (SCM)NULL;
	PANEL* C__scm_pan;
	C__scm_pan = (PANEL*)SCM_CDR(_scm_pan);
	SCM_ret = SCM_MAKINUM(top_panel(C__scm_pan));
	return SCM_ret;
}

SCM
scm_curses_touchline(SCM _scm_win, SCM _scm_start, SCM _scm_count)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_start;
	int C__scm_count;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_start = SCM_INUM(_scm_start);
	C__scm_count = SCM_INUM(_scm_count);
	SCM_ret = SCM_MAKINUM(touchline(C__scm_win, C__scm_start, C__scm_count));
	return SCM_ret;
}

SCM
scm_curses_touchwin(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(touchwin(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_typeahead(SCM _scm_fd)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_fd;
	C__scm_fd = SCM_INUM(_scm_fd);
	SCM_ret = SCM_MAKINUM(typeahead(C__scm_fd));
	return SCM_ret;
}

SCM
scm_curses_ungetch(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_ch;
	C__scm_ch = SCM_INUM(_scm_ch);
	SCM_ret = SCM_MAKINUM(ungetch(C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_untouchwin(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(untouchwin(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_vidattr(SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_attrs;
	C__scm_attrs = (chtype)SCM_CDR(_scm_attrs);
	SCM_ret = SCM_MAKINUM(vidattr(C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_vline(SCM _scm_ch, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	int C__scm_n;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(vline(C__scm_ch, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_waddch(SCM _scm_win, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(waddch(C__scm_win, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_waddchnstr(SCM _scm_win, SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(waddchnstr(C__scm_win, C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_waddchstr(SCM _scm_win, SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype* C__scm_chstr;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(waddchstr(C__scm_win, C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_waddnstr(SCM _scm_win, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(waddnstr(C__scm_win, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_waddstr(SCM _scm_win, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(waddstr(C__scm_win, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_wattr_off(SCM _scm_win, SCM _scm_attrs, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	attr_t C__scm_attrs;
	void* C__scm_opts;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(wattr_off(C__scm_win, C__scm_attrs, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_wattr_on(SCM _scm_win, SCM _scm_attrs, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	attr_t C__scm_attrs;
	void* C__scm_opts;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(wattr_on(C__scm_win, C__scm_attrs, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_wattr_set(SCM _scm_win, SCM _scm_attrs, SCM _scm_pair, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	attr_t C__scm_attrs;
	short C__scm_pair;
	void* C__scm_opts;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_attrs = (attr_t)SCM_CDR(_scm_attrs);
	C__scm_pair = (short)SCM_INUM(_scm_pair);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(wattr_set(C__scm_win, C__scm_attrs, C__scm_pair, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_wattroff(SCM _scm_win, SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_attrs;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_attrs = SCM_INUM(_scm_attrs);
	SCM_ret = SCM_MAKINUM(wattroff(C__scm_win, C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_wattron(SCM _scm_win, SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_attrs;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_attrs = SCM_INUM(_scm_attrs);
	SCM_ret = SCM_MAKINUM(wattron(C__scm_win, C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_wattrset(SCM _scm_win, SCM _scm_attrs)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_attrs;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_attrs = SCM_INUM(_scm_attrs);
	SCM_ret = SCM_MAKINUM(wattrset(C__scm_win, C__scm_attrs));
	return SCM_ret;
}

SCM
scm_curses_wbkgd(SCM _scm_win, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(wbkgd(C__scm_win, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_wborder(SCM _scm_win, SCM _scm_ls, SCM _scm_rs, SCM _scm_ts, SCM _scm_bs, SCM _scm_tl, SCM _scm_tr, SCM _scm_bl, SCM _scm_br)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ls;
	chtype C__scm_rs;
	chtype C__scm_ts;
	chtype C__scm_bs;
	chtype C__scm_tl;
	chtype C__scm_tr;
	chtype C__scm_bl;
	chtype C__scm_br;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ls = (chtype)SCM_CDR(_scm_ls);
	C__scm_rs = (chtype)SCM_CDR(_scm_rs);
	C__scm_ts = (chtype)SCM_CDR(_scm_ts);
	C__scm_bs = (chtype)SCM_CDR(_scm_bs);
	C__scm_tl = (chtype)SCM_CDR(_scm_tl);
	C__scm_tr = (chtype)SCM_CDR(_scm_tr);
	C__scm_bl = (chtype)SCM_CDR(_scm_bl);
	C__scm_br = (chtype)SCM_CDR(_scm_br);
	SCM_ret = SCM_MAKINUM(wborder(C__scm_win, C__scm_ls, C__scm_rs, C__scm_ts, C__scm_bs, C__scm_tl, C__scm_tr, C__scm_bl, C__scm_br));
	return SCM_ret;
}

SCM
scm_curses_wchgat(SCM _scm_win, SCM _scm_n, SCM _scm_attr, SCM _scm_color, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_n;
	attr_t C__scm_attr;
	short C__scm_color;
	void* C__scm_opts;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_n = SCM_INUM(_scm_n);
	C__scm_attr = (attr_t)SCM_CDR(_scm_attr);
	C__scm_color = (short)SCM_INUM(_scm_color);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(wchgat(C__scm_win, C__scm_n, C__scm_attr, C__scm_color, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_wclear(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wclear(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wclrtobot(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wclrtobot(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wclrtoeol(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wclrtoeol(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wcolor_set(SCM _scm_win, SCM _scm_color_pair_number, SCM _scm_opts)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	short C__scm_color_pair_number;
	void* C__scm_opts;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_color_pair_number = (short)SCM_INUM(_scm_color_pair_number);
	C__scm_opts = SCM2PTR(_scm_opts);
	SCM_ret = SCM_MAKINUM(wcolor_set(C__scm_win, C__scm_color_pair_number, C__scm_opts));
	return SCM_ret;
}

SCM
scm_curses_wdelch(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wdelch(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wdeleteln(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wdeleteln(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wechochar(SCM _scm_win, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(wechochar(C__scm_win, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_werase(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(werase(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wgetch(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wgetch(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wgetnstr(SCM _scm_win, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(wgetnstr(C__scm_win, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_wgetstr(SCM _scm_win, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(wgetstr(C__scm_win, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_whline(SCM _scm_win, SCM _scm_ch, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(whline(C__scm_win, C__scm_ch, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_winchnstr(SCM _scm_win, SCM _scm_chstr, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype* C__scm_chstr;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(winchnstr(C__scm_win, C__scm_chstr, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_winchstr(SCM _scm_win, SCM _scm_chstr)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype* C__scm_chstr;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_chstr = (chtype*)SCM_CDR(_scm_chstr);
	SCM_ret = SCM_MAKINUM(winchstr(C__scm_win, C__scm_chstr));
	return SCM_ret;
}

SCM
scm_curses_winnstr(SCM _scm_win, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(winnstr(C__scm_win, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_winsch(SCM _scm_win, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	SCM_ret = SCM_MAKINUM(winsch(C__scm_win, C__scm_ch));
	return SCM_ret;
}

SCM
scm_curses_winsdelln(SCM _scm_win, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(winsdelln(C__scm_win, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_winsertln(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(winsertln(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_winsnstr(SCM _scm_win, SCM _scm_str, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(winsnstr(C__scm_win, C__scm_str, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_winsstr(SCM _scm_win, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(winsstr(C__scm_win, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_winstr(SCM _scm_win, SCM _scm_str)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	char* C__scm_str;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_str = SCM_CHARS(_scm_str);
	SCM_ret = SCM_MAKINUM(winstr(C__scm_win, C__scm_str));
	return SCM_ret;
}

SCM
scm_curses_wmove(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	SCM_ret = SCM_MAKINUM(wmove(C__scm_win, C__scm_y, C__scm_x));
	return SCM_ret;
}

SCM
scm_curses_wnoutrefresh(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wnoutrefresh(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wredrawln(SCM _scm_win, SCM _scm_beg_line, SCM _scm_num_lines)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_beg_line;
	int C__scm_num_lines;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_beg_line = SCM_INUM(_scm_beg_line);
	C__scm_num_lines = SCM_INUM(_scm_num_lines);
	SCM_ret = SCM_MAKINUM(wredrawln(C__scm_win, C__scm_beg_line, C__scm_num_lines));
	return SCM_ret;
}

SCM
scm_curses_wrefresh(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wrefresh(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wresize(SCM _scm_win, SCM _scm_lines, SCM _scm_columns)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_lines;
	int C__scm_columns;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_lines = SCM_INUM(_scm_lines);
	C__scm_columns = SCM_INUM(_scm_columns);
	SCM_ret = SCM_MAKINUM(wresize(C__scm_win, C__scm_lines, C__scm_columns));
	return SCM_ret;
}

SCM
scm_curses_wscrl(SCM _scm_win, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(wscrl(C__scm_win, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_wsetscrreg(SCM _scm_win, SCM _scm_top, SCM _scm_bot)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_top;
	int C__scm_bot;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_top = SCM_INUM(_scm_top);
	C__scm_bot = SCM_INUM(_scm_bot);
	SCM_ret = SCM_MAKINUM(wsetscrreg(C__scm_win, C__scm_top, C__scm_bot));
	return SCM_ret;
}

SCM
scm_curses_wstandend(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wstandend(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wstandout(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	SCM_ret = SCM_MAKINUM(wstandout(C__scm_win));
	return SCM_ret;
}

SCM
scm_curses_wtouchln(SCM _scm_win, SCM _scm_y, SCM _scm_n, SCM _scm_changed)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_n;
	int C__scm_changed;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_n = SCM_INUM(_scm_n);
	C__scm_changed = SCM_INUM(_scm_changed);
	SCM_ret = SCM_MAKINUM(wtouchln(C__scm_win, C__scm_y, C__scm_n, C__scm_changed));
	return SCM_ret;
}

SCM
scm_curses_wvline(SCM _scm_win, SCM _scm_ch, SCM _scm_n)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	int C__scm_n;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	C__scm_n = SCM_INUM(_scm_n);
	SCM_ret = SCM_MAKINUM(wvline(C__scm_win, C__scm_ch, C__scm_n));
	return SCM_ret;
}

SCM
scm_curses_bkgdset(SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	chtype C__scm_ch;
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	bkgdset(C__scm_ch);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_delscreen(SCM _scm_sp)
{
	SCM SCM_ret = (SCM)NULL;
	SCREEN* C__scm_sp;
	C__scm_sp = (SCREEN*)SCM_CDR(_scm_sp);
	delscreen(C__scm_sp);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_filter()
{
	SCM SCM_ret = (SCM)NULL;
	filter();
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_getbegyx(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	getbegyx(C__scm_win, C__scm_y, C__scm_x);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_getmaxyx(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	getmaxyx(C__scm_win, C__scm_y, C__scm_x);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_getparyx(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	getparyx(C__scm_win, C__scm_y, C__scm_x);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_getsyx(SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	getsyx(C__scm_y, C__scm_x);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_getyx(SCM _scm_win, SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_y;
	int C__scm_x;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	getyx(C__scm_win, C__scm_y, C__scm_x);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_idcok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	idcok(C__scm_win, C__scm_bf);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_immedok(SCM _scm_win, SCM _scm_bf)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	bool C__scm_bf;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_bf = ((_scm_bf)==SCM_BOOL_T)?TRUE:FALSE;
	immedok(C__scm_win, C__scm_bf);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_noqiflush()
{
	SCM SCM_ret = (SCM)NULL;
	noqiflush();
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_qiflush()
{
	SCM SCM_ret = (SCM)NULL;
	qiflush();
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_setsyx(SCM _scm_y, SCM _scm_x)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_y;
	int C__scm_x;
	C__scm_y = SCM_INUM(_scm_y);
	C__scm_x = SCM_INUM(_scm_x);
	setsyx(C__scm_y, C__scm_x);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_timeout(SCM _scm_delay)
{
	SCM SCM_ret = (SCM)NULL;
	int C__scm_delay;
	C__scm_delay = SCM_INUM(_scm_delay);
	timeout(C__scm_delay);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_update_panels()
{
	SCM SCM_ret = (SCM)NULL;
	update_panels();
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_use_env(SCM _scm_f)
{
	SCM SCM_ret = (SCM)NULL;
	bool C__scm_f;
	C__scm_f = ((_scm_f)==SCM_BOOL_T)?TRUE:FALSE;
	use_env(C__scm_f);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_wbkgdset(SCM _scm_win, SCM _scm_ch)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	chtype C__scm_ch;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_ch = (chtype)SCM_CDR(_scm_ch);
	wbkgdset(C__scm_win, C__scm_ch);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_wcursyncup(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	wcursyncup(C__scm_win);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_wsyncdown(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	wsyncdown(C__scm_win);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_wsyncup(SCM _scm_win)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	wsyncup(C__scm_win);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}

SCM
scm_curses_wtimeout(SCM _scm_win, SCM _scm_delay)
{
	SCM SCM_ret = (SCM)NULL;
	WINDOW* C__scm_win;
	int C__scm_delay;
	C__scm_win = (WINDOW*)SCM_CDR(_scm_win);
	C__scm_delay = SCM_INUM(_scm_delay);
	wtimeout(C__scm_win, C__scm_delay);
	SCM_ret = SCM_UNDEFINED;
	return SCM_ret;
}


void init_curses()
{	SCM tmp;


	SMOB_PANEL_ptr = scm_make_smob_type("PANEL*", sizeof(PANEL*));
	SMOB_SCREEN_ptr = scm_make_smob_type("SCREEN*", sizeof(SCREEN*));
	SMOB_TERMINAL_ptr = scm_make_smob_type("TERMINAL*", sizeof(TERMINAL*));
	SMOB_WINDOW_ptr = scm_make_smob_type("WINDOW*", sizeof(WINDOW*));
	SMOB_attr_t = scm_make_smob_type("attr_t", sizeof(attr_t));
	SMOB_chtype = scm_make_smob_type("chtype", sizeof(chtype));
	SMOB_chtype_ptr = scm_make_smob_type("chtype*", sizeof(chtype*));
	SMOB_mmask_t = scm_make_smob_type("mmask_t", sizeof(mmask_t));

	gh_define ("ERR", SCM_MAKINUM(ERR));
	gh_define ("COLOR_BLACK", SCM_MAKINUM(COLOR_BLACK));
	gh_define ("COLOR_RED", SCM_MAKINUM(COLOR_RED));
	gh_define ("COLOR_GREEN", SCM_MAKINUM(COLOR_GREEN));
	gh_define ("COLOR_YELLOW", SCM_MAKINUM(COLOR_YELLOW));
	gh_define ("COLOR_BLUE", SCM_MAKINUM(COLOR_BLUE));
	gh_define ("COLOR_MAGENTA", SCM_MAKINUM(COLOR_MAGENTA));
	gh_define ("COLOR_CYAN", SCM_MAKINUM(COLOR_CYAN));
	gh_define ("COLOR_WHITE", SCM_MAKINUM(COLOR_WHITE));
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_ULCORNER);
	gh_define("ACS_ULCORNER", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_LLCORNER);
	gh_define("ACS_LLCORNER", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_URCORNER);
	gh_define("ACS_URCORNER", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_LRCORNER);
	gh_define("ACS_LRCORNER", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_LTEE);
	gh_define("ACS_LTEE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_RTEE);
	gh_define("ACS_RTEE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BTEE);
	gh_define("ACS_BTEE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_TTEE);
	gh_define("ACS_TTEE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_HLINE);
	gh_define("ACS_HLINE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_VLINE);
	gh_define("ACS_VLINE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_PLUS);
	gh_define("ACS_PLUS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_S1);
	gh_define("ACS_S1", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_S9);
	gh_define("ACS_S9", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_DIAMOND);
	gh_define("ACS_DIAMOND", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_CKBOARD);
	gh_define("ACS_CKBOARD", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_DEGREE);
	gh_define("ACS_DEGREE", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_PLMINUS);
	gh_define("ACS_PLMINUS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BULLET);
	gh_define("ACS_BULLET", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_LARROW);
	gh_define("ACS_LARROW", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_RARROW);
	gh_define("ACS_RARROW", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_DARROW);
	gh_define("ACS_DARROW", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_UARROW);
	gh_define("ACS_UARROW", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BOARD);
	gh_define("ACS_BOARD", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_LANTERN);
	gh_define("ACS_LANTERN", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BLOCK);
	gh_define("ACS_BLOCK", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_S3);
	gh_define("ACS_S3", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_S7);
	gh_define("ACS_S7", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_LEQUAL);
	gh_define("ACS_LEQUAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_GEQUAL);
	gh_define("ACS_GEQUAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_PI);
	gh_define("ACS_PI", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_NEQUAL);
	gh_define("ACS_NEQUAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_STERLING);
	gh_define("ACS_STERLING", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BSSB);
	gh_define("ACS_BSSB", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SSBB);
	gh_define("ACS_SSBB", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BBSS);
	gh_define("ACS_BBSS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SBBS);
	gh_define("ACS_SBBS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SBSS);
	gh_define("ACS_SBSS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SSSB);
	gh_define("ACS_SSSB", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SSBS);
	gh_define("ACS_SSBS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BSSS);
	gh_define("ACS_BSSS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_BSBS);
	gh_define("ACS_BSBS", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SBSB);
	gh_define("ACS_SBSB", tmp);
	SCM_NEWSMOB(tmp, SMOB_chtype, ACS_SSSS);
	gh_define("ACS_SSSS", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_ATTRIBUTES);
	gh_define("WA_ATTRIBUTES", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_NORMAL);
	gh_define("WA_NORMAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_STANDOUT);
	gh_define("WA_STANDOUT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_UNDERLINE);
	gh_define("WA_UNDERLINE", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_REVERSE);
	gh_define("WA_REVERSE", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_BLINK);
	gh_define("WA_BLINK", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_DIM);
	gh_define("WA_DIM", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_BOLD);
	gh_define("WA_BOLD", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_ALTCHARSET);
	gh_define("WA_ALTCHARSET", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_INVIS);
	gh_define("WA_INVIS", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_PROTECT);
	gh_define("WA_PROTECT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_HORIZONTAL);
	gh_define("WA_HORIZONTAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_LEFT);
	gh_define("WA_LEFT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_LOW);
	gh_define("WA_LOW", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_RIGHT);
	gh_define("WA_RIGHT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_TOP);
	gh_define("WA_TOP", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, WA_VERTICAL);
	gh_define("WA_VERTICAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_NORMAL);
	gh_define("A_NORMAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_ATTRIBUTES);
	gh_define("A_ATTRIBUTES", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_CHARTEXT);
	gh_define("A_CHARTEXT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_COLOR);
	gh_define("A_COLOR", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_STANDOUT);
	gh_define("A_STANDOUT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_UNDERLINE);
	gh_define("A_UNDERLINE", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_REVERSE);
	gh_define("A_REVERSE", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_BLINK);
	gh_define("A_BLINK", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_DIM);
	gh_define("A_DIM", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_BOLD);
	gh_define("A_BOLD", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_ALTCHARSET);
	gh_define("A_ALTCHARSET", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_INVIS);
	gh_define("A_INVIS", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_PROTECT);
	gh_define("A_PROTECT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_HORIZONTAL);
	gh_define("A_HORIZONTAL", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_LEFT);
	gh_define("A_LEFT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_LOW);
	gh_define("A_LOW", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_RIGHT);
	gh_define("A_RIGHT", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_TOP);
	gh_define("A_TOP", tmp);
	SCM_NEWSMOB(tmp, SMOB_attr_t, A_VERTICAL);
	gh_define("A_VERTICAL", tmp);

	gh_new_procedure("new_panel", scm_curses_new_panel, 1, 0, 0);
	gh_new_procedure("panel_above", scm_curses_panel_above, 1, 0, 0);
	gh_new_procedure("panel_below", scm_curses_panel_below, 1, 0, 0);
	gh_new_procedure("set_term", scm_curses_set_term, 1, 0, 0);
	gh_new_procedure("set_curterm", scm_curses_set_curterm, 1, 0, 0);
	gh_new_procedure("derwin", scm_curses_derwin, 5, 0, 0);
	gh_new_procedure("dupwin", scm_curses_dupwin, 1, 0, 0);
	gh_new_procedure("initscr", scm_curses_initscr, 0, 0, 0);
	gh_new_procedure("newpad", scm_curses_newpad, 2, 0, 0);
	gh_new_procedure("newwin", scm_curses_newwin, 4, 0, 0);
	gh_new_procedure("panel_window", scm_curses_panel_window, 1, 0, 0);
	gh_new_procedure("subpad", scm_curses_subpad, 5, 0, 0);
	gh_new_procedure("subwin", scm_curses_subwin, 5, 0, 0);
	gh_new_procedure("slk_attr", scm_curses_slk_attr, 0, 0, 0);
	gh_new_procedure("termattrs", scm_curses_termattrs, 0, 0, 0);
	gh_new_procedure("can_change_color", scm_curses_can_change_color, 0, 0, 0);
	gh_new_procedure("has_colors", scm_curses_has_colors, 0, 0, 0);
	gh_new_procedure("has_ic", scm_curses_has_ic, 0, 0, 0);
	gh_new_procedure("has_il", scm_curses_has_il, 0, 0, 0);
	gh_new_procedure("is_linetouched", scm_curses_is_linetouched, 2, 0, 0);
	gh_new_procedure("is_wintouched", scm_curses_is_wintouched, 1, 0, 0);
	gh_new_procedure("isendwin", scm_curses_isendwin, 0, 0, 0);
	gh_new_procedure("wenclose", scm_curses_wenclose, 3, 0, 0);
	gh_new_procedure("keyname", scm_curses_keyname, 1, 0, 0);
	gh_new_procedure("longname", scm_curses_longname, 0, 0, 0);
	gh_new_procedure("slk_label", scm_curses_slk_label, 1, 0, 0);
	gh_new_procedure("termname", scm_curses_termname, 0, 0, 0);
	gh_new_procedure("tgoto", scm_curses_tgoto, 3, 0, 0);
	gh_new_procedure("tigetstr", scm_curses_tigetstr, 1, 0, 0);
	gh_new_procedure("unctrl", scm_curses_unctrl, 1, 0, 0);
	gh_new_procedure("erasechar", scm_curses_erasechar, 0, 0, 0);
	gh_new_procedure("killchar", scm_curses_killchar, 0, 0, 0);
	gh_new_procedure("getbkgd", scm_curses_getbkgd, 1, 0, 0);
	gh_new_procedure("inch", scm_curses_inch, 0, 0, 0);
	gh_new_procedure("mvinch", scm_curses_mvinch, 2, 0, 0);
	gh_new_procedure("mvwinch", scm_curses_mvwinch, 3, 0, 0);
	gh_new_procedure("winch", scm_curses_winch, 1, 0, 0);
	gh_new_procedure("panel_userptr", scm_curses_panel_userptr, 1, 0, 0);
	gh_new_procedure("addch", scm_curses_addch, 1, 0, 0);
	gh_new_procedure("addchnstr", scm_curses_addchnstr, 2, 0, 0);
	gh_new_procedure("addchstr", scm_curses_addchstr, 1, 0, 0);
	gh_new_procedure("addnstr", scm_curses_addnstr, 2, 0, 0);
	gh_new_procedure("addstr", scm_curses_addstr, 1, 0, 0);
	gh_new_procedure("attr_off", scm_curses_attr_off, 2, 0, 0);
	gh_new_procedure("attr_on", scm_curses_attr_on, 2, 0, 0);
	gh_new_procedure("attr_set", scm_curses_attr_set, 3, 0, 0);
	gh_new_procedure("attroff", scm_curses_attroff, 1, 0, 0);
	gh_new_procedure("attron", scm_curses_attron, 1, 0, 0);
	gh_new_procedure("attrset", scm_curses_attrset, 1, 0, 0);
	gh_new_procedure("baudrate", scm_curses_baudrate, 0, 0, 0);
	gh_new_procedure("beep", scm_curses_beep, 0, 0, 0);
	gh_new_procedure("bkgd", scm_curses_bkgd, 1, 0, 0);
	gh_new_procedure("border", scm_curses_border, 8, 0, 0);
	gh_new_procedure("bottom_panel", scm_curses_bottom_panel, 1, 0, 0);
	gh_new_procedure("box", scm_curses_box, 3, 0, 0);
	gh_new_procedure("cbreak", scm_curses_cbreak, 0, 0, 0);
	gh_new_procedure("chgat", scm_curses_chgat, 4, 0, 0);
	gh_new_procedure("clear", scm_curses_clear, 0, 0, 0);
	gh_new_procedure("clearok", scm_curses_clearok, 2, 0, 0);
	gh_new_procedure("clrtobot", scm_curses_clrtobot, 0, 0, 0);
	gh_new_procedure("clrtoeol", scm_curses_clrtoeol, 0, 0, 0);
	gh_new_procedure("color_set", scm_curses_color_set, 2, 0, 0);
	gh_new_procedure("copywin", scm_curses_copywin, 9, 0, 0);
	gh_new_procedure("curs_set", scm_curses_curs_set, 1, 0, 0);
	gh_new_procedure("def_prog_mode", scm_curses_def_prog_mode, 0, 0, 0);
	gh_new_procedure("def_shell_mode", scm_curses_def_shell_mode, 0, 0, 0);
	gh_new_procedure("del_curterm", scm_curses_del_curterm, 1, 0, 0);
	gh_new_procedure("del_panel", scm_curses_del_panel, 1, 0, 0);
	gh_new_procedure("delay_output", scm_curses_delay_output, 1, 0, 0);
	gh_new_procedure("delch", scm_curses_delch, 0, 0, 0);
	gh_new_procedure("deleteln", scm_curses_deleteln, 0, 0, 0);
	gh_new_procedure("delwin", scm_curses_delwin, 1, 0, 0);
	gh_new_procedure("doupdate", scm_curses_doupdate, 0, 0, 0);
	gh_new_procedure("echo", scm_curses_echo, 0, 0, 0);
	gh_new_procedure("echochar", scm_curses_echochar, 1, 0, 0);
	gh_new_procedure("endwin", scm_curses_endwin, 0, 0, 0);
	gh_new_procedure("erase", scm_curses_erase, 0, 0, 0);
	gh_new_procedure("flash", scm_curses_flash, 0, 0, 0);
	gh_new_procedure("flushinp", scm_curses_flushinp, 0, 0, 0);
	gh_new_procedure("getch", scm_curses_getch, 0, 0, 0);
	gh_new_procedure("getnstr", scm_curses_getnstr, 2, 0, 0);
	gh_new_procedure("getstr", scm_curses_getstr, 1, 0, 0);
	gh_new_procedure("halfdelay", scm_curses_halfdelay, 1, 0, 0);
	gh_new_procedure("has_key", scm_curses_has_key, 1, 0, 0);
	gh_new_procedure("hide_panel", scm_curses_hide_panel, 1, 0, 0);
	gh_new_procedure("hline", scm_curses_hline, 2, 0, 0);
	gh_new_procedure("idlok", scm_curses_idlok, 2, 0, 0);
	gh_new_procedure("inchnstr", scm_curses_inchnstr, 2, 0, 0);
	gh_new_procedure("inchstr", scm_curses_inchstr, 1, 0, 0);
	gh_new_procedure("init_color", scm_curses_init_color, 4, 0, 0);
	gh_new_procedure("COLOR_PAIR", scm_curses_COLOR_PAIR, 1, 0, 0);
	gh_new_procedure("init_pair", scm_curses_init_pair, 3, 0, 0);
	gh_new_procedure("innstr", scm_curses_innstr, 2, 0, 0);
	gh_new_procedure("insch", scm_curses_insch, 1, 0, 0);
	gh_new_procedure("insdelln", scm_curses_insdelln, 1, 0, 0);
	gh_new_procedure("insertln", scm_curses_insertln, 0, 0, 0);
	gh_new_procedure("insnstr", scm_curses_insnstr, 2, 0, 0);
	gh_new_procedure("insstr", scm_curses_insstr, 1, 0, 0);
	gh_new_procedure("instr", scm_curses_instr, 1, 0, 0);
	gh_new_procedure("intrflush", scm_curses_intrflush, 2, 0, 0);
	gh_new_procedure("keypad", scm_curses_keypad, 2, 0, 0);
	gh_new_procedure("leaveok", scm_curses_leaveok, 2, 0, 0);
	gh_new_procedure("mcprint", scm_curses_mcprint, 2, 0, 0);
	gh_new_procedure("meta", scm_curses_meta, 2, 0, 0);
	gh_new_procedure("mouseinterval", scm_curses_mouseinterval, 1, 0, 0);
	gh_new_procedure("move", scm_curses_move, 2, 0, 0);
	gh_new_procedure("move_panel", scm_curses_move_panel, 3, 0, 0);
	gh_new_procedure("mvaddch", scm_curses_mvaddch, 3, 0, 0);
	gh_new_procedure("mvaddchnstr", scm_curses_mvaddchnstr, 4, 0, 0);
	gh_new_procedure("mvaddchstr", scm_curses_mvaddchstr, 3, 0, 0);
	gh_new_procedure("mvaddnstr", scm_curses_mvaddnstr, 4, 0, 0);
	gh_new_procedure("mvaddstr", scm_curses_mvaddstr, 3, 0, 0);
	gh_new_procedure("mvchgat", scm_curses_mvchgat, 6, 0, 0);
	gh_new_procedure("mvcur", scm_curses_mvcur, 4, 0, 0);
	gh_new_procedure("mvdelch", scm_curses_mvdelch, 2, 0, 0);
	gh_new_procedure("mvderwin", scm_curses_mvderwin, 3, 0, 0);
	gh_new_procedure("mvgetch", scm_curses_mvgetch, 2, 0, 0);
	gh_new_procedure("mvgetnstr", scm_curses_mvgetnstr, 4, 0, 0);
	gh_new_procedure("mvgetstr", scm_curses_mvgetstr, 3, 0, 0);
	gh_new_procedure("mvinchnstr", scm_curses_mvinchnstr, 4, 0, 0);
	gh_new_procedure("mvinchstr", scm_curses_mvinchstr, 3, 0, 0);
	gh_new_procedure("mvinnstr", scm_curses_mvinnstr, 4, 0, 0);
	gh_new_procedure("mvinsch", scm_curses_mvinsch, 3, 0, 0);
	gh_new_procedure("mvinsnstr", scm_curses_mvinsnstr, 4, 0, 0);
	gh_new_procedure("mvinsstr", scm_curses_mvinsstr, 3, 0, 0);
	gh_new_procedure("mvinstr", scm_curses_mvinstr, 3, 0, 0);
	gh_new_procedure("mvvline", scm_curses_mvvline, 4, 0, 0);
	gh_new_procedure("mvwaddch", scm_curses_mvwaddch, 4, 0, 0);
	gh_new_procedure("mvwaddchnstr", scm_curses_mvwaddchnstr, 5, 0, 0);
	gh_new_procedure("mvwaddchstr", scm_curses_mvwaddchstr, 4, 0, 0);
	gh_new_procedure("mvwaddnstr", scm_curses_mvwaddnstr, 5, 0, 0);
	gh_new_procedure("mvwaddstr", scm_curses_mvwaddstr, 4, 0, 0);
	gh_new_procedure("mvwchgat", scm_curses_mvwchgat, 7, 0, 0);
	gh_new_procedure("mvwdelch", scm_curses_mvwdelch, 3, 0, 0);
	gh_new_procedure("mvwgetch", scm_curses_mvwgetch, 3, 0, 0);
	gh_new_procedure("mvwgetnstr", scm_curses_mvwgetnstr, 5, 0, 0);
	gh_new_procedure("mvwgetstr", scm_curses_mvwgetstr, 4, 0, 0);
	gh_new_procedure("mvwin", scm_curses_mvwin, 3, 0, 0);
	gh_new_procedure("mvwinchnstr", scm_curses_mvwinchnstr, 5, 0, 0);
	gh_new_procedure("mvwinchstr", scm_curses_mvwinchstr, 4, 0, 0);
	gh_new_procedure("mvwinnstr", scm_curses_mvwinnstr, 5, 0, 0);
	gh_new_procedure("mvwinsch", scm_curses_mvwinsch, 4, 0, 0);
	gh_new_procedure("mvwinsnstr", scm_curses_mvwinsnstr, 5, 0, 0);
	gh_new_procedure("mvwinsstr", scm_curses_mvwinsstr, 4, 0, 0);
	gh_new_procedure("mvwinstr", scm_curses_mvwinstr, 4, 0, 0);
	gh_new_procedure("mvwvline", scm_curses_mvwvline, 5, 0, 0);
	gh_new_procedure("napms", scm_curses_napms, 1, 0, 0);
	gh_new_procedure("nl", scm_curses_nl, 0, 0, 0);
	gh_new_procedure("nocbreak", scm_curses_nocbreak, 0, 0, 0);
	gh_new_procedure("nodelay", scm_curses_nodelay, 2, 0, 0);
	gh_new_procedure("noecho", scm_curses_noecho, 0, 0, 0);
	gh_new_procedure("nonl", scm_curses_nonl, 0, 0, 0);
	gh_new_procedure("noraw", scm_curses_noraw, 0, 0, 0);
	gh_new_procedure("notimeout", scm_curses_notimeout, 2, 0, 0);
	gh_new_procedure("overlay", scm_curses_overlay, 2, 0, 0);
	gh_new_procedure("overwrite", scm_curses_overwrite, 2, 0, 0);
	gh_new_procedure("panel_hidden", scm_curses_panel_hidden, 1, 0, 0);
	gh_new_procedure("pechochar", scm_curses_pechochar, 2, 0, 0);
	gh_new_procedure("pnoutrefresh", scm_curses_pnoutrefresh, 7, 0, 0);
	gh_new_procedure("prefresh", scm_curses_prefresh, 7, 0, 0);
	gh_new_procedure("putp", scm_curses_putp, 1, 0, 0);
	gh_new_procedure("raw", scm_curses_raw, 0, 0, 0);
	gh_new_procedure("redrawwin", scm_curses_redrawwin, 1, 0, 0);
	gh_new_procedure("refresh", scm_curses_refresh, 0, 0, 0);
	gh_new_procedure("replace_panel", scm_curses_replace_panel, 2, 0, 0);
	gh_new_procedure("reset_prog_mode", scm_curses_reset_prog_mode, 0, 0, 0);
	gh_new_procedure("reset_shell_mode", scm_curses_reset_shell_mode, 0, 0, 0);
	gh_new_procedure("resetty", scm_curses_resetty, 0, 0, 0);
	gh_new_procedure("resizeterm", scm_curses_resizeterm, 2, 0, 0);
	gh_new_procedure("savetty", scm_curses_savetty, 0, 0, 0);
	gh_new_procedure("scr_dump", scm_curses_scr_dump, 1, 0, 0);
	gh_new_procedure("scr_init", scm_curses_scr_init, 1, 0, 0);
	gh_new_procedure("scr_restore", scm_curses_scr_restore, 1, 0, 0);
	gh_new_procedure("scr_set", scm_curses_scr_set, 1, 0, 0);
	gh_new_procedure("scrl", scm_curses_scrl, 1, 0, 0);
	gh_new_procedure("scroll", scm_curses_scroll, 1, 0, 0);
	gh_new_procedure("scrollok", scm_curses_scrollok, 2, 0, 0);
	gh_new_procedure("set_panel_userptr", scm_curses_set_panel_userptr, 2, 0, 0);
	gh_new_procedure("setscrreg", scm_curses_setscrreg, 2, 0, 0);
	gh_new_procedure("setterm", scm_curses_setterm, 1, 0, 0);
	gh_new_procedure("show_panel", scm_curses_show_panel, 1, 0, 0);
	gh_new_procedure("slk_attr_off", scm_curses_slk_attr_off, 2, 0, 0);
	gh_new_procedure("slk_attr_on", scm_curses_slk_attr_on, 2, 0, 0);
	gh_new_procedure("slk_attr_set", scm_curses_slk_attr_set, 3, 0, 0);
	gh_new_procedure("slk_attroff", scm_curses_slk_attroff, 1, 0, 0);
	gh_new_procedure("slk_attron", scm_curses_slk_attron, 1, 0, 0);
	gh_new_procedure("slk_attrset", scm_curses_slk_attrset, 1, 0, 0);
	gh_new_procedure("slk_clear", scm_curses_slk_clear, 0, 0, 0);
	gh_new_procedure("slk_color", scm_curses_slk_color, 1, 0, 0);
	gh_new_procedure("slk_init", scm_curses_slk_init, 1, 0, 0);
	gh_new_procedure("slk_noutrefresh", scm_curses_slk_noutrefresh, 0, 0, 0);
	gh_new_procedure("slk_refresh", scm_curses_slk_refresh, 0, 0, 0);
	gh_new_procedure("slk_restore", scm_curses_slk_restore, 0, 0, 0);
	gh_new_procedure("slk_set", scm_curses_slk_set, 3, 0, 0);
	gh_new_procedure("slk_touch", scm_curses_slk_touch, 0, 0, 0);
	gh_new_procedure("standend", scm_curses_standend, 0, 0, 0);
	gh_new_procedure("standout", scm_curses_standout, 0, 0, 0);
	gh_new_procedure("start_color", scm_curses_start_color, 0, 0, 0);
	gh_new_procedure("syncok", scm_curses_syncok, 2, 0, 0);
	gh_new_procedure("tgetent", scm_curses_tgetent, 2, 0, 0);
	gh_new_procedure("tgetflag", scm_curses_tgetflag, 1, 0, 0);
	gh_new_procedure("tgetnum", scm_curses_tgetnum, 1, 0, 0);
	gh_new_procedure("tigetflag", scm_curses_tigetflag, 1, 0, 0);
	gh_new_procedure("tigetnum", scm_curses_tigetnum, 1, 0, 0);
	gh_new_procedure("top_panel", scm_curses_top_panel, 1, 0, 0);
	gh_new_procedure("touchline", scm_curses_touchline, 3, 0, 0);
	gh_new_procedure("touchwin", scm_curses_touchwin, 1, 0, 0);
	gh_new_procedure("typeahead", scm_curses_typeahead, 1, 0, 0);
	gh_new_procedure("ungetch", scm_curses_ungetch, 1, 0, 0);
	gh_new_procedure("untouchwin", scm_curses_untouchwin, 1, 0, 0);
	gh_new_procedure("vidattr", scm_curses_vidattr, 1, 0, 0);
	gh_new_procedure("vline", scm_curses_vline, 2, 0, 0);
	gh_new_procedure("waddch", scm_curses_waddch, 2, 0, 0);
	gh_new_procedure("waddchnstr", scm_curses_waddchnstr, 3, 0, 0);
	gh_new_procedure("waddchstr", scm_curses_waddchstr, 2, 0, 0);
	gh_new_procedure("waddnstr", scm_curses_waddnstr, 3, 0, 0);
	gh_new_procedure("waddstr", scm_curses_waddstr, 2, 0, 0);
	gh_new_procedure("wattr_off", scm_curses_wattr_off, 3, 0, 0);
	gh_new_procedure("wattr_on", scm_curses_wattr_on, 3, 0, 0);
	gh_new_procedure("wattr_set", scm_curses_wattr_set, 4, 0, 0);
	gh_new_procedure("wattroff", scm_curses_wattroff, 2, 0, 0);
	gh_new_procedure("wattron", scm_curses_wattron, 2, 0, 0);
	gh_new_procedure("wattrset", scm_curses_wattrset, 2, 0, 0);
	gh_new_procedure("wbkgd", scm_curses_wbkgd, 2, 0, 0);
	gh_new_procedure("wborder", scm_curses_wborder, 9, 0, 0);
	gh_new_procedure("wchgat", scm_curses_wchgat, 5, 0, 0);
	gh_new_procedure("wclear", scm_curses_wclear, 1, 0, 0);
	gh_new_procedure("wclrtobot", scm_curses_wclrtobot, 1, 0, 0);
	gh_new_procedure("wclrtoeol", scm_curses_wclrtoeol, 1, 0, 0);
	gh_new_procedure("wcolor_set", scm_curses_wcolor_set, 3, 0, 0);
	gh_new_procedure("wdelch", scm_curses_wdelch, 1, 0, 0);
	gh_new_procedure("wdeleteln", scm_curses_wdeleteln, 1, 0, 0);
	gh_new_procedure("wechochar", scm_curses_wechochar, 2, 0, 0);
	gh_new_procedure("werase", scm_curses_werase, 1, 0, 0);
	gh_new_procedure("wgetch", scm_curses_wgetch, 1, 0, 0);
	gh_new_procedure("wgetnstr", scm_curses_wgetnstr, 3, 0, 0);
	gh_new_procedure("wgetstr", scm_curses_wgetstr, 2, 0, 0);
	gh_new_procedure("whline", scm_curses_whline, 3, 0, 0);
	gh_new_procedure("winchnstr", scm_curses_winchnstr, 3, 0, 0);
	gh_new_procedure("winchstr", scm_curses_winchstr, 2, 0, 0);
	gh_new_procedure("winnstr", scm_curses_winnstr, 3, 0, 0);
	gh_new_procedure("winsch", scm_curses_winsch, 2, 0, 0);
	gh_new_procedure("winsdelln", scm_curses_winsdelln, 2, 0, 0);
	gh_new_procedure("winsertln", scm_curses_winsertln, 1, 0, 0);
	gh_new_procedure("winsnstr", scm_curses_winsnstr, 3, 0, 0);
	gh_new_procedure("winsstr", scm_curses_winsstr, 2, 0, 0);
	gh_new_procedure("winstr", scm_curses_winstr, 2, 0, 0);
	gh_new_procedure("wmove", scm_curses_wmove, 3, 0, 0);
	gh_new_procedure("wnoutrefresh", scm_curses_wnoutrefresh, 1, 0, 0);
	gh_new_procedure("wredrawln", scm_curses_wredrawln, 3, 0, 0);
	gh_new_procedure("wrefresh", scm_curses_wrefresh, 1, 0, 0);
	gh_new_procedure("wresize", scm_curses_wresize, 3, 0, 0);
	gh_new_procedure("wscrl", scm_curses_wscrl, 2, 0, 0);
	gh_new_procedure("wsetscrreg", scm_curses_wsetscrreg, 3, 0, 0);
	gh_new_procedure("wstandend", scm_curses_wstandend, 1, 0, 0);
	gh_new_procedure("wstandout", scm_curses_wstandout, 1, 0, 0);
	gh_new_procedure("wtouchln", scm_curses_wtouchln, 4, 0, 0);
	gh_new_procedure("wvline", scm_curses_wvline, 3, 0, 0);
	gh_new_procedure("bkgdset", scm_curses_bkgdset, 1, 0, 0);
	gh_new_procedure("delscreen", scm_curses_delscreen, 1, 0, 0);
	gh_new_procedure("filter", scm_curses_filter, 0, 0, 0);
	gh_new_procedure("getbegyx", scm_curses_getbegyx, 3, 0, 0);
	gh_new_procedure("getmaxyx", scm_curses_getmaxyx, 3, 0, 0);
	gh_new_procedure("getparyx", scm_curses_getparyx, 3, 0, 0);
	gh_new_procedure("getsyx", scm_curses_getsyx, 2, 0, 0);
	gh_new_procedure("getyx", scm_curses_getyx, 3, 0, 0);
	gh_new_procedure("idcok", scm_curses_idcok, 2, 0, 0);
	gh_new_procedure("immedok", scm_curses_immedok, 2, 0, 0);
	gh_new_procedure("noqiflush", scm_curses_noqiflush, 0, 0, 0);
	gh_new_procedure("qiflush", scm_curses_qiflush, 0, 0, 0);
	gh_new_procedure("setsyx", scm_curses_setsyx, 2, 0, 0);
	gh_new_procedure("timeout", scm_curses_timeout, 1, 0, 0);
	gh_new_procedure("update_panels", scm_curses_update_panels, 0, 0, 0);
	gh_new_procedure("use_env", scm_curses_use_env, 1, 0, 0);
	gh_new_procedure("wbkgdset", scm_curses_wbkgdset, 2, 0, 0);
	gh_new_procedure("wcursyncup", scm_curses_wcursyncup, 1, 0, 0);
	gh_new_procedure("wsyncdown", scm_curses_wsyncdown, 1, 0, 0);
	gh_new_procedure("wsyncup", scm_curses_wsyncup, 1, 0, 0);
	gh_new_procedure("wtimeout", scm_curses_wtimeout, 2, 0, 0);
	gh_new_procedure("get-stdscr", scm_curses_get_stdscr, 0, 0, 0);
 	gh_new_procedure("string->chstr", scm_curses_string2chstr, 1, 0, 0);
 	gh_new_procedure("chstr->string", scm_curses_chstr2string, 1, 0, 0);
	gh_new_procedure("chstr-ref", scm_curses_chstr_ref, 2, 0, 0);
	gh_new_procedure("chstr-set!", scm_curses_chstr_set, 3, 0, 0);
	gh_new_procedure("chstr-apply!", scm_curses_chstr_apply_bang, 2, 2, 0);
	return;
}

